#pragma once

#include <map>

// Stores known types of actors
enum class ActorType : int {
    PUPPY = 218,
    JACK_IN_THE_BOX = 73,
    SQUIRREL = 165,
    EVIL_CAR = 109,
    CRATE = 52,
    JASPER = 208,
    PORTAL = 94,
    FLOWERS1 = 384,
    DUST = 16,
    PARROT = 101,
    FLOWERS2 = 168,
    MONKEY = 163,
    PUNCHING_BAG = 82,
    EXPLODING_CAR = 75,
    CAT = 191,
    FLY_PAD = 24,
    GENERIC = 0,
    SQUIRTER = 24,
    ARMY_GUY = 199,
    CLOWN = 24,
    TANK = 110,
    SEWER_COVER = 154,
    PROJECTILE = 12,
    HORACE = 222,
    BAT = 98,
    BLIMP = 40,
    MAP_PROP = 14,
    HELICOPTER = 66,
    CRUELLA_HELICOPTER = 225,
    CATAPULT = 105,
    PINEAPPLE_PROJECTILE = 21,
    KNIGHT = 138,
    TOASTER = 140,
	RAT = 136,
	BOAT = 126,
	CROC = 106,
	DEVIL = 190,
	BULLDOZER = 70,
	PLANE = 92,
	MOLE = 126,
	PENGUIN = 78,
	TREE = 51,
	RABBIT = 147,
};

// Map for translation of ActorType enums to a const char*
static std::map<ActorType, const char*> actor_type_names {
    { ActorType::PUPPY, "Puppy" },
    { ActorType::JACK_IN_THE_BOX, "Jack in the Box" },
    { ActorType::SQUIRREL, "Squirrel" },
    { ActorType::EVIL_CAR, "Evil Car" },
    { ActorType::CRATE, "Crate" },
    { ActorType::JASPER, "Jasper" },
    { ActorType::PORTAL, "Portal" },
    { ActorType::FLOWERS1, "Flowers" },
    { ActorType::DUST, "Dust" },
    { ActorType::PARROT, "Parrot" },
    { ActorType::FLOWERS2, "Flowers" },
    { ActorType::MONKEY, "Monkey" },
    { ActorType::PUNCHING_BAG, "Punching Bag" },
    { ActorType::EXPLODING_CAR, "Exploding Car" },
    { ActorType::CAT, "Cat" },
    { ActorType::FLY_PAD, "Fly Pad" },
    { ActorType::GENERIC, "Generic" },
    { ActorType::SQUIRTER, "Squirter" },
    { ActorType::ARMY_GUY, "Army Guy" },
    { ActorType::CLOWN, "Clown" },
    { ActorType::TANK, "Tank" },
    { ActorType::SEWER_COVER, "Sewer Cover" },
    { ActorType::PROJECTILE, "Projectile" },
    { ActorType::HORACE, "Horace" },
    { ActorType::BAT, "Bat" },
    { ActorType::BLIMP, "Blimp" },
    { ActorType::MAP_PROP, "Map Prop" },
    { ActorType::HELICOPTER, "Helicopter" },
    { ActorType::CRUELLA_HELICOPTER, "Cruella Helicopter" },
    { ActorType::CATAPULT, "Catapult" },
    { ActorType::PINEAPPLE_PROJECTILE, "Pineapple" },
    { ActorType::KNIGHT, "Knight" },
    { ActorType::TOASTER, "Toaster" },
    { ActorType::RAT, "Rat" },
    { ActorType::BOAT, "Boat" },
    { ActorType::CROC, "Croc" },
    { ActorType::DEVIL, "Devil" },
    { ActorType::BULLDOZER, "Bulldozer" },
    { ActorType::PLANE, "Plane" },
    { ActorType::MOLE, "Mole" },
    { ActorType::PENGUIN, "Penguin" },
    { ActorType::TREE, "Tree" },
    { ActorType::RABBIT, "Rabbit" },
};